unit Address;   //   FTN-
interface

uses SysUtils;

type TAddr=class(TObject)
       private
        Zone,
        Net,
        Node,
        Point:Integer;
        Domain:String;
       public

       constructor Create;virtual;
       destructor Destroy;override;
       // 
       procedure SetZone(NewZone:Word);
       procedure SetNet(NewNet:Word);
       procedure SetNode(NewNode:Word);
       procedure SetPoint(NewPoint:Word);
       procedure SetDomain(NewDomain:String);
       //
       function GetZone:word;
       function GetNet:Word;
       function GetNode:Word;
       function GetPoint:Word;
       function GetDomain:String;

       procedure ParseStr(Adr:String); //  
                                       //  Zone:net/node[.point][@domain]
       function GetStr:String; //      :))

      end;

implementation

constructor TAddr.Create;
begin
inherited Create;
Zone:=-1;
Net:=-1;
Node:=-1;
Point:=-1;
domain:='';
end; //TAddr.Create;

destructor TAddr.Destroy;
begin
inherited Destroy;
end;


procedure TAddr.SetZone(NewZone:Word);
begin
Zone:=NewZone;
end; //TAddr.SetZone

procedure Taddr.SetNet(NewNet:Word);
begin
Net:=NewNet;
end; //Taddr.SetNet

procedure TAddr.SetNode(NewNode:Word);
begin
Node:=NewNode;
end;  //TAddr.SetNode

procedure TAddr.SetPoint(NewPoint:Word);
begin
Point:=NewPoint;
end;  //TAddr.SetPoint

procedure TAddr.SetDomain(NewDomain:String);
begin
Domain:=NewDomain;
end;  //TAddr.SetDomain

function TAddr.GetZone:word;
begin
GetZone:=Zone;
end;  //TAddr.GetZone

function TAddr.GetNet:Word;
begin
GetNet:=Net;
end;  //TAddr.GetNet

function TAddr.GetNode:Word;
begin
GetNode:=Node;
end;  //GetNode:

function TAddr.GetPoint:Word;
begin
GetPoint:=Point;
end;  //TAddr.GetPoint

function TAddr.GetDomain:String;
begin
GetDomain:=Domain;
end;  //TAddr.GetDomain

procedure TAddr.ParseStr(Adr:String); //  
                                       //  Zone:net/node[.point][@domain]
var t:integer;
    s1:string;
begin
t:=pos('@',adr);
if t<>0 then //  
          begin
           Domain:=Copy(Adr,t+1,255);
           delete(adr,t,255);
          end;
t:=pos('.',adr);
if t<>0 then // 
          begin
           s1:=copy(adr,t+1,255);
           point:=StrToInt(s1);
           delete(adr,t,255);
          end else point:=0;
t:=pos(':',adr);
s1:=copy(adr,1,t-1);
zone:=StrToInt(s1);
delete(adr,1,t);

t:=pos('/',adr);
s1:=copy(adr,1,t-1);
Net:=StrToInt(s1);
delete(adr,1,t);

Node:=StrToInt(adr);
end;

function TAddr.GetStr:String; //  Zone:net/node[.point][@domain]
begin
Result:=IntToStr(Zone)+':';
result:=result+IntToStr(Net)+'/'+IntToStr(Node);
if point<>0 then result:=result+'.'+IntToStr(point);
if domain<>'' then result:=result+'@'+domain;
end;

end.
