unit DatTime;

interface
uses SysUtils;

type Marr=array[1..12] of string[3];
     TMonth=^Marr;

const Eng:Marr =('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
      rus:Marr =('','','','','','','','','','','','');

var Lang:Word;    //
    Month:TMonth; // 

const lngEnglish=0;
      lngRussian=1;

//     FTSC-0001
// 25_Jan_98__02:12:46#0


procedure SetRussian;  //   
procedure SetEnglish;  //   

function DateTimeToMsgStr(dt:TDateTime):string; //    TDateTime
function CurrentToMsgStr:string;  //    /

function MsgStrToDateTime(MsgStr:String):TDateTime; //   -  TDateTime



implementation

procedure SetRussian;  //   
begin
Lang:=lngRussian;
Month:=@rus;
end;

procedure SetEnglish;  //   
begin
Lang:=lngEnglish;
Month:=@eng;
end;

function DateTimeToMsgStr(dt:TDateTime):string;
begin
Result:=DateTimeToStr(dt);
Result:=copy(Result,1,8)+' '+copy(Result,9,255);
Result[3]:=' ';
Result[6]:=' ';
result:=copy(Result,1,3)+Month^[StrToInt(copy(Result,4,2))]+copy(Result,6,255);
while length(result)<20 do result:=result+#0;
end;

function CurrentToMsgStr:string;  //    /
begin
result:=DateTimeToMsgStr(Now);
end;


function MsgStrToDateTime(MsgStr:String):TDateTime; //   -  TDateTime
var s1:string;
    t:integer;
    Find:Boolean;
begin
s1:=copy(MsgStr,4,3);
s1:=AnsiUpperCase(s1);

find:=False;
for t:=1 to 12 do
if s1=AnsiUpperCase(Eng[t]) then
                         begin
                          Find:=True;
                          break;
                         end;
if not Find then
 for t:=1 to 12 do
 if s1=AnsiUpperCase(Rus[t]) then
                          begin
                           Find:=True;
                           break;
                          end;
 if not Find then
                begin
                 result:=StrToDateTime('01.01.81 00:00:00');
                 exit;
                end;
s1:=IntToStr(t);
if length(s1)=1 then s1:='0'+s1;
result:=StrToDateTime(copy(MsgStr,1,2)+'.'+s1+'.'+copy(MsgStr,8,255));
end;


initialization
begin
DateSeparator:='.';   //
TimeSeparator:=':';
ShortDateFormat:='dd.MM.yy';
ShortTimeFormat:='HH:mm:ss';
Lang:=lngEnglish;
SetEnglish;
end;

end.
